Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Types.h	(revision 97)
@@ -152,24 +152,4 @@
 
 }; // end namespace behavioural
-
-  inline std::string toString_type(const morpheo::behavioural::Ttype_t& x)
-  {
-    switch (x)
-      {
-      case TYPE_ALU     : return "ALU"        ; break;
-      case TYPE_SHIFT   : return "SHIFT"      ; break;
-      case TYPE_MOVE    : return "MOVE"       ; break;
-      case TYPE_TEST    : return "TEST"       ; break;
-      case TYPE_MUL     : return "MUL"        ; break;
-      case TYPE_DIV     : return "DIV"        ; break;
-      case TYPE_EXTEND  : return "EXTEND"     ; break;
-      case TYPE_FIND    : return "FIND"       ; break;
-      case TYPE_SPECIAL : return "SPECIAL"    ; break;
-      case TYPE_CUSTOM  : return "CUSTOM"     ; break;
-      case TYPE_BRANCH  : return "BRANCH"     ; break;
-      case TYPE_MEMORY  : return "MEMORY"     ; break;
-      default           : return "Unknow type"; break;
-      }
-  };
 
   template<> inline std::string toString<morpheo::behavioural::Tpriority_t>(const morpheo::behavioural::Tpriority_t& x)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Version.h	(revision 97)
@@ -10,8 +10,8 @@
 #define MORPHEO_MAJOR_VERSION 0
 #define MORPHEO_MINOR_VERSION 2
-#define MORPHEO_REVISION      "96"
+#define MORPHEO_REVISION      "97"
 #define MORPHEO_CODENAME      "Castor"
 
-#define MORPHEO_DATE_DAY      "16"  
+#define MORPHEO_DATE_DAY      "19"  
 #define MORPHEO_DATE_MONTH    "12"
 #define MORPHEO_DATE_YEAR     "2008" 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Vhdl.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Vhdl.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Vhdl.h	(revision 97)
@@ -23,12 +23,15 @@
   namespace behavioural          {
 
-    std::string std_logic          (uint32_t size);
-    std::string std_logic_conv     (uint32_t size, std::string   value);
-    std::string std_logic_conv     (uint32_t size, uint32_t value);
-    std::string std_logic_cst      (uint32_t size, uint32_t value);
-    std::string std_logic_range    (uint32_t size, uint32_t max , uint32_t min , bool force=false);
-    std::string std_logic_range    (               uint32_t max , uint32_t min , bool force=false);
-    std::string std_logic_range    (uint32_t size,                               bool force=false);
-    std::string std_logic_others   (uint32_t size, bool cst);
+    std::string std_logic        (uint32_t size);
+    std::string std_logic_conv   (uint32_t size, std::string   value);
+    std::string std_logic_conv   (uint32_t size, uint32_t value);
+    std::string std_logic_cst    (uint32_t size, uint32_t value);
+    std::string std_logic_range  (uint32_t size, uint32_t max , uint32_t min );
+    std::string std_logic_range  (               uint32_t max , uint32_t min );
+    std::string std_logic_range  (uint32_t size                              );
+    std::string _std_logic_range (uint32_t size, uint32_t max , uint32_t min );
+    std::string _std_logic_range (               uint32_t max , uint32_t min );
+    std::string _std_logic_range (uint32_t size                              );
+    std::string std_logic_others (uint32_t size, bool cst);
 
     class Vhdl
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_test_map.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_test_map.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Component_test_map.cpp	(revision 97)
@@ -48,16 +48,17 @@
 	 i != _list_component->end();
 	 ++i)
-      {
-	test_ok &= (*i)->_entity->test_map(depth+1,false,is_behavioural);
-	if (recursive)
-	  try 
-	    {
-	      test_ok &= (*i)->_component->test_map(depth+1,recursive);
-	    }
-	  catch (morpheo::ErrorMorpheo & error)
-	    {
-	      // no error propagation, only top level
-	    }
-      }
+      if (((*i)->_instance & INSTANCE_COMPONENT) != 0)
+        {
+          test_ok &= (*i)->_entity->test_map(depth+1,false,is_behavioural);
+          if (recursive)
+            try 
+              {
+                test_ok &= (*i)->_component->test_map(depth+1,recursive);
+              }
+            catch (morpheo::ErrorMorpheo & error)
+              {
+                // no error propagation, only top level
+              }
+        }
     
     log_printf(FUNC,Behavioural,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp	(revision 97)
@@ -1,3 +1,4 @@
 #include "Behavioural/include/SPR_access_mode.h"
+// #include "Common/include/Debug.h"
 
 namespace morpheo {
@@ -15,4 +16,9 @@
 
     spr_access_mode_t mode = _spr_generic [num_group][num_reg];
+//     log_printf(TRACE,true,"exist","  * exist");
+//     log_printf(TRACE,true,"exist","    * num_group              : %d",num_group);
+//     log_printf(TRACE,true,"exist","    * num_register           : %d",num_reg);
+//     log_printf(TRACE,true,"exist","    * supervisor_access_mode : %d",mode._supervisor_access_mode);
+//     log_printf(TRACE,true,"exist","    * user_access_mode       : %d",mode._user_access_mode      );
 
     return ((mode._supervisor_access_mode != SPR_ACCESS_MODE_NONE) or
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp	(revision 97)
@@ -33,14 +33,14 @@
     	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][  20]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
     	    
-    	    const uint32_t nb_shadow = 1;
+    	    const uint32_t nb_shadow = 1; // max 16
     	    
-    	    for (uint32_t i=32; i<=32+nb_shadow; i++)
-    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
-    	    for (uint32_t i=48; i<=48+nb_shadow; i++)
-    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
-    	    for (uint32_t i=64; i<=64+nb_shadow; i++)
-    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
-    	    for (uint32_t i=1024; i<=1024+32*nb_shadow; i++)
-    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
+    	    for (uint32_t i=32; i<32+nb_shadow; i++)
+    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
+    	    for (uint32_t i=48; i<48+nb_shadow; i++)
+    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
+    	    for (uint32_t i=64; i<64+nb_shadow; i++)
+    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
+//     	    for (uint32_t i=1024; i<1024+32*nb_shadow; i++)
+//     	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
 
 	    break;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_std_logic.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_std_logic.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Vhdl_std_logic.cpp	(revision 97)
@@ -80,25 +80,22 @@
 #undef  FUNCTION
 #define FUNCTION "Vhdl::std_logic_range"
-  std::string std_logic_range (uint32_t size, uint32_t max, uint32_t min, bool force)
+  std::string std_logic_range (uint32_t size, uint32_t max, uint32_t min)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
     std::string type;
 
-    if (force)
       {
-        type = "("+toString(max)+" downto "+toString(min)+")";
-      }
-    else
-      {
-        if (max == min)
-          {
-            type = "("+toString(max)+")";
-          }
+        if (size < 2)
+          type = "";
         else
           {
-            if (size < 2)
-              type = "";
+            if (max == min)
+              {
+                type = "("+toString(max)+")";
+              }
             else
-              type = "("+toString(max)+" downto "+toString(min)+")";
+              {
+                type = "("+toString(max)+" downto "+toString(min)+")";
+              }
           }
       }
@@ -109,14 +106,9 @@
   };
 
-  std::string std_logic_range (uint32_t max, uint32_t min, bool force)
+  std::string std_logic_range (uint32_t max, uint32_t min)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
     std::string type;
 
-    if (force)
-      {
-        type = "("+toString(max)+" downto "+toString(min)+")";
-      }
-    else
       {
         if (max == min)
@@ -138,8 +130,37 @@
   };
 
-  std::string std_logic_range (uint32_t size, bool force)
+  std::string std_logic_range (uint32_t size)
   {
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
-    std::string _return = std_logic_range(size-1,0,force);
+    std::string _return = std_logic_range(size,size-1,0);
+    log_printf(FUNC,Behavioural,FUNCTION,"End");
+
+    return _return;
+  }
+
+#undef  FUNCTION
+#define FUNCTION "Vhdl::_std_logic_range"
+  std::string _std_logic_range (uint32_t size, uint32_t max, uint32_t min)
+  {
+    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+    std::string type=_std_logic_range(max,min);
+    log_printf(FUNC,Behavioural,FUNCTION,"End");
+
+    return type;
+  };
+
+  std::string _std_logic_range (uint32_t max, uint32_t min)
+  {
+    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+    std::string type = "("+toString(max)+" downto "+toString(min)+")";
+    log_printf(FUNC,Behavioural,FUNCTION,"End");
+
+    return type;
+  };
+
+  std::string _std_logic_range (uint32_t size)
+  {
+    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+    std::string _return = _std_logic_range(size,size-1,0);
     log_printf(FUNC,Behavioural,FUNCTION,"End");
 
